#!/usr/bin/env python

import pygtk
pygtk.require('2.0')

import gtk
from gtk import glade

from threading import Thread

class UI:
    def push_status(self,  message):
        id = self.sbar.get_context_id(message)
        self.sbar.push(id,  message)
        gtk.main_iteration()
        return True
    
    def pulse_total(self, count_total):
        self.pbar_total.set_fraction(count_total)
        self.pbar_total.set_text("Total: "+str(int(count_total*100))+"%")
        gtk.main_iteration()
        return True
    
    def pulse_file(self, *hook):
        done = hook[0] * hook[1]
        total = hook[2]
        fraction = 0.0
        if done < total:
            fraction = float(done ) / float(total)
            self.pbar_file.set_fraction(fraction)
            self.pbar_file.set_text("File: "+str(int(fraction*100))+"%")
        else:
            self.pbar_file.set_text("100%")
            self.pbar_file.set_fraction(1.0)
        gtk.main_iteration()
        return True

    def pulse(self, *hook):
	self.pbar_total.set_text("Working...")
	self.pbar_total.pulse()
	return True

    def openSettings(self,  w,  updater):
        self.hostfeeld.set_text(updater.host)
        self.listfilefeeld.set_text(updater.xml_indexfile)
        self.filechoser.set_filename(updater.UIFolder)
        self.settings_window.show_all()
        return

    def closeSettings(self,  w,  updater):
        if w.get_name() == "Ssave_btn":
            updater.saveSettings(self)
        self.settings_window.hide()
        return

    def __init__(self,  updater):
        # Initialize the Userinterface.
        self.ui = glade.XML("PyEQ2MAPUpdater.glade")
        
        # Progressbarrs.
        self.pbar_total = self.ui.get_widget("progressbar_total")
        self.pbar_file = self.ui.get_widget("progressbar_file")
        
        #Statusbar
        self.sbar = self.ui.get_widget("statusbar1")
        
        # Assign MainWindow event actions.
        self.ui.signal_connect("on_Quit_btn_clicked",  updater.quit_app)
        self.ui.signal_connect("on_Update_btn_clicked",  updater.update,  self)
        self.ui.signal_connect("on_Cancel_btn_clicked",  updater.cancel,  self)
        self.ui.signal_connect("on_Settings_btn_clicked", self.openSettings,  updater)
        
        # Settings Window
        self.settings_window = self.ui.get_widget("Settings")
        self.hostfeeld = self.ui.get_widget("entry_host")
        self.listfilefeeld = self.ui.get_widget("entry_listfile")
        self.filechoser = self.ui.get_widget("filechooserbutton1")
        
        # Settings Window event actions.
        self.ui.signal_connect("on_Ssave_btn_clicked", self.closeSettings,  updater)
        self.ui.signal_connect("on_Scancel_btn_clicked", self.closeSettings,  updater)
        
        #Get Window and show all.
        self.window = self.ui.get_widget("PyEQ2MAP")
        self.window.show_all()
        
